//**************************************//
//*  Clock Generator                   *//
//*    (c) AIST & Tohoku Univ.         *//
//*                                    *//
//*    File name   : CLK_GEN.v         *//
//*    Version     : Version 1.0       *//
//*    Created     : APRIL/01/2007     *//
//*    Last update : JULY/22/2007      *//
//**************************************//
`timescale 1ns / 1ps

module CLK_GEN (CLK, RSTn_HW, BaudRate, BaudRate16);

input   CLK,RSTn_HW;
output  BaudRate,BaudRate16;
                                //Baud_rate = ENABLE of para_seri
                                //Baud_rate16 = CE of seri_para

reg   [7:0] Rate_count;
reg   [3:0] Rate16_count;

always @( posedge CLK ) begin   //communication speed*16 153600bps
    if (!RSTn_HW)
        Rate16_count <= 4'h0;
    else if (Rate16_count == 4'hd)
        Rate16_count <= 4'h0;
    else
        Rate16_count <= Rate16_count + 4'h1;
end

always @(posedge CLK) begin      //communication spped 9600bps
    if (!RSTn_HW)
        Rate_count <= 8'h0;
    else if (Rate_count == 8'hd0)
        Rate_count <= 8'h0;
    else
        Rate_count <= Rate_count + 8'h1;
end

    assign  BaudRate16 = (Rate16_count == 4'hd);  // CE of seri_para
    assign  BaudRate = (Rate_count == 8'hd0);     // ENABLE of para_seri

endmodule
