//*************************************//
//*  SASEBO top module (FPGA1)         *//
//*    (c) AIST & Tohoku Univ.         *//
//*                                    *//
//*    File name   : SASEBO_TOP.v      *//
//*    Version     : Version 1.02      *//
//*    Created     : APRIL/27/2007     *//
//*    Last update : AUG/31/2007       *//
//**************************************//


module top_wrapper(CLK, RSTn_HW, RXD, TXD, Status_n, OK);
  input  CLK, RSTn_HW, RXD;
  output TXD;
  output [3:0] Status_n;
  output OK;

//  wire CLK0;
//  wire CLKDV;
//  wire CLKFX;

  // DCM is only for test purpose, and this code does not use DCM

//  DCM #(
//    .CLKDV_DIVIDE(12),   // 2MHz clock
//    .CLKFX_DIVIDE(1),
//    .CLKFX_MULTIPLY(4),
//    .CLKIN_DIVIDE_BY_2("FALSE"),
//    .CLKOUT_PHASE_SHIFT("NONE"),
//    .CLK_FEEDBACK("1X"),
//    .DESKEW_ADJUST("SYSTEM_SYNCHRONOUS"),
//    .DFS_FREQUENCY_MODE("LOW"),
//    .DLL_FREQUENCY_MODE("LOW"),
//    .DUTY_CYCLE_CORRECTION("TRUE"),
//    .PHASE_SHIFT(0),
//    .STARTUP_WAIT("FALSE")
//  )
//
//  DCM_inst (
//    .CLK0 (CLK0),
//    .CLKDV(CLKDV),
//    .CLKFX(CLKFX),
//    .CLKFB(CLK0),
//    .CLKIN(CLK),
//    .RST(0)
//   );

top top (CLK, RSTn_HW, RXD, TXD, BSY, Kvld, Dvld, Status_n, OK);

endmodule // top_wrapper


module top (CLK, RSTn_HW, RXD, TXD, BSY, Kvld, Dvld, Status_n, OK);
input  CLK, RSTn_HW, RXD;
output TXD, BSY, Kvld, Dvld;
output [3:0] Status_n;
output OK;

wire  Drdy, Krdy, Svld; 
wire  BaudRate, BaudRate16;
wire  TXDn;
wire  [127:0] Din;
wire  [127:0] Dout;
wire  EncDec, EN, RSTn;
wire  SPrst, SPstatus, PSstatus;
wire  [3:0] Cmd, Status;

CLK_GEN   U0 (CLK, RSTn_HW, BaudRate, BaudRate16);
seri_para U1 (CLK, RSTn, RSTn_HW, BaudRate16, RXD,
              Din, Krdy, Drdy, EncDec, EN, SPrst, PSstatus,Cmd);
AES_TOP   U2 (Din, Dout, Drdy, Krdy, EncDec, RSTn, RSTn_HW,
              EN, CLK, BSY, Svld, Kvld, Dvld, Status);
para_seri U3 (CLK, RSTn_HW, BaudRate, Svld, Dout,
              TXDn, SPrst, SPstatus, PSstatus, Cmd, Status);

assign TXD      = TXDn;
assign SPrst    = SPstatus & PSstatus;
assign Status_n = ~Status;
assign OK       = Status[3];

endmodule